export declare function toPairs<T>(object: Record<string, T>): Array<[string, T]>;
type ObjectKeys<T extends object> = `${Exclude<keyof T, symbol>}`;
type ObjectValues<T extends Record<PropertyKey, unknown>> = Required<T>[ObjectKeys<T>];
type ObjectEntry<T extends Record<PropertyKey, unknown>> = [
    ObjectKeys<T>,
    ObjectValues<T>
];
type ObjectEntries<T extends Record<PropertyKey, unknown>> = Array<ObjectEntry<T>>;
export declare namespace toPairs {
    function strict<T extends Record<PropertyKey, unknown>>(object: T): ObjectEntries<T>;
}
export {};
//# sourceMappingURL=toPairs.d.ts.map